//Script by Amade, model by Shizza04

%error = ForceRequiredAddOn("Weapon_Gun");
if(%error == $Error::AddOn_Disabled)
{
   gunItem.uiName = "";
}

datablock AudioProfile(shar15EquipSound)
{
   filename    = "./ar15Deploy.wav";
   description = AudioClose3d;
   preload     = true;
};
datablock AudioProfile(shar15ShotSound)
{
   filename    = "./ar15Fire.wav";
   description = AudioClose3d;
   preload     = true;
};
//shell
datablock DebrisData(shar15ShellDebris)
{
	shapeFile = "./casing.dts";
	lifetime = 5.0;
	minSpinSpeed = 700.0;
	maxSpinSpeed = 800.0;
	elasticity = 0.6;
	friction = 0.1;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};


AddDamageType("shar15", '<bitmap:add-ons/Weapon_AR-15/ci> %1', '%2 <bitmap:add-ons/Weapon_AR-15/ci> %1',0.2,1);

datablock ProjectileData(shar15Projectile : gunProjectile)
{
   directDamage     = 15;
   directDamageType = $DamageType::shar15;
   radiusDamageType = $DamageType::shar15;
   impactImpulse    = 100;
   verticalImpulse  = 10;
   muzzleVelocity   = 135;
   velInheritFactor = 1;
   uiName           = "AR-15 Bullet";
};

datablock ItemData(shar15Item : GunItem)
{
   shapeFile       = "./AR15_item.dts";
   uiName          = "AR-15";
   iconName = "./icon_ar15";
   doColorShift = true;
   colorShiftColor = "1.0 1.0 1.0 1.000";

   image   = shar15Image;
   canDrop   = true;
};

datablock ShapeBaseImageData(shar15Image : GunImage)
{
   shapeFile  = "./AR15.dts";
   emap = true;
   
   casing = shar15ShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 7.5;
   projectile = shar15Projectile;
   
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.5 0.7 -0.65";
   rotation = eulerToMatrix( "0 0 0" );

   doColorShift    = shar15Item.doColorShift;
   colorShiftColor = shar15Item.colorShiftColor;

   stateName[0]                   = "Activate";
   stateSequence[0]               = "Ready";
   stateTimeoutValue[0]           = 0.15;
   stateTransitionOnTimeout[0]    = "Ready";
   stateSound[0]                  = shar15EquipSound;

   stateName[1]                   = "Ready";
   stateSequence[1]               = "Ready";
   stateTransitionOnTriggerDown[1]= "Fire";
   stateAllowImageChange[1]       = true;
   stateSequence[1]               = "Ready";

   stateName[2]                   = "Fire";
   stateTransitionOnTimeout[2]    = "Reload";
   stateTimeoutValue[2]           = 0.08;
   stateFire[2]                   = true;
   stateAllowImageChange[2]       = false;
   stateSequence[2]               = "Fire";
   stateScript[2]                 = "onFire";
   stateWaitForTimeout[2]         = true;
   stateEmitter[2]                = gunFlashEmitter;
   stateEmitterTime[2]            = 0.05;
   stateEmitterNode[2]            = "muzzleNode";
   stateSound[2]                  = shar15ShotSound;
   stateEjectShell[2]             = true;

   stateName[3]                   = "Smoke";
   stateEmitter[3]                = gunSmokeEmitter;
   stateEmitterTime[3]            = 0.5;
   stateEmitterNode[3]            = "muzzleNode";
   stateTimeoutValue[3]           = 0.01;
   stateTransitionOnTimeout[3]    = "Ready";

   stateName[4]                   = "Reload";
   stateSequence[4]               = "Reload";
   stateTransitionOnTriggerUp[4]  = "Smoke";
   stateTransitionOnTriggerDown[4]= "Fire";
   stateSequence[4]               = "Ready";
};

//Ephialtes' bullet spread coding
function shar15Image::onFire(%this, %obj, %slot)
{
   %spread = 0.0015;
   %projectile = %this.projectile;
   %vector = %obj.getMuzzleVector(%slot);
   %objectVelocity = %obj.getVelocity();
   %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
   %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
   %velocity = VectorAdd(%vector1,%vector2);
   %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
   %velocity = MatrixMulVector(%mat, %velocity);
   %p = new (%this.projectileType)()
   {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
   };
   MissionCleanup.add(%p);
}